
Redmine - Defect #37138

Mentions of users with "@" in their username

2022-05-19 11:38 - David Robinson

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Marius BĂLTEANU % Done: 0%

Category: Email notifications Estimated time: 0.00 hour

Target version: 5.0.2   

Resolution: Fixed Affected version: 5.0.0

Description

When mentioning a user that has an "@" in their username no email is sent to the user.

Associated revisions

Revision 21660 - 2022-06-20 07:50 - Marius BĂLTEANU

Fix mentions of users with "@" in their username not working (#37138).

Revision 21664 - 2022-06-20 17:16 - Marius BĂLTEANU

Fix random failing test (#37138).

Revision 21665 - 2022-06-20 17:17 - Marius BĂLTEANU

Merged r21660 to 5.0-stable (#37138).

Revision 21666 - 2022-06-20 17:17 - Marius BĂLTEANU

Merged r21664 to 5.0-stable (#37138).

History

#1 - 2022-05-19 11:39 - David Robinson

Usernames here are often of the form: user@domain.tld

#2 - 2022-05-20 13:21 - VD DV

We have same behavior at our 5.0 installation.

#3 - 2022-05-20 13:28 - David Robinson

VD DV wrote:

We have same behavior at our 5.0 installation.

 In case you want a workaround while this is fixed, I have made the following in a "plugin" to fix it here:

Redmine::Acts::Mentionable::InstanceMethods.module_eval do

        def scan_for_mentioned_users(content)

          return [] if content.nil?

          # remove quoted text

          content = content.gsub(%r{\r\n(?:\>\s)+(.*?)\r\n}m, '')

          text_formatting = Setting.text_formatting

          # Remove text wrapped in pre tags based on text formatting

          case text_formatting

          when 'textile'

            content = content.gsub(%r{&lt;pre&gt;(.*?)&lt;/pre&gt;}m, '')

          when 'markdown', 'common_mark'

            content = content.gsub(%r{(~~~|```)(.*?)(~~~|```)}m, '')

          end

          users = content.scan(MENTION_PATTERN).flatten

        end
    MENTION_PATTERN = /

        (?:^|\W)                    # beginning of string or non-word char

        @((?&gt;[a-z0-9][@\.a-z0-9-]*))   # @username

        (?!\/)                      # without a trailing slash

        (?=

            \.+[ \t\W]|               # dots followed by space or non-word character

            \.+$|                     # dots at end of line

            [^0-9a-zA-Z_.]|           # non-word character except dot

            $                         # end of line

        )

    /ix

end

This works here, but I have no idea if there are some quirky edge-cases where it might break.

You can either make a plugin with it, or just patch the lib/redmine/acts/mentionable file.

#4 - 2022-05-27 20:54 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

- Target version set to 5.0.2

#5 - 2022-06-20 07:54 - Marius BĂLTEANU

- Category set to Email notifications

- Status changed from New to Resolved

- Resolution set to Fixed

Fix committed. I've reused the Regex from user links.

#6 - 2022-06-20 17:19 - Marius BĂLTEANU

- Status changed from Resolved to Closed
